"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var Msal = require("msal");
var MsalService = /** @class */ (function () {
    function MsalService() {
    }
    MsalService.prototype.init = function (configuration) {
        this.config = configuration;
        this.app = new Msal.UserAgentApplication(this.config.clientID, '', function () { });
    };
    Object.defineProperty(MsalService.prototype, "authenticated", {
        get: function () {
            var user = this.app.getUser();
            if (user) {
                return true;
            }
            return false;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MsalService.prototype, "token", {
        get: function () {
            var token = this.getToken();
            return token;
        },
        enumerable: true,
        configurable: true
    });
    MsalService.prototype.login = function () {
        var _this = this;
        return this.app.loginPopup(this.config.graphScopes)
            .then(function (idToken) {
            var user = _this.app.getUser();
            if (user) {
                return user;
            }
            else {
                return null;
            }
        }, function () {
            return null;
        });
    };
    MsalService.prototype.logout = function () {
        this.app.logout();
    };
    MsalService.prototype.getToken = function () {
        var _this = this;
        return this.app.acquireTokenSilent(this.config.graphScopes)
            .then(function (accessToken) {
            return accessToken;
        }, function (error) {
            return _this.app.acquireTokenPopup(_this.config.graphScopes)
                .then(function (accessToken) {
                return accessToken;
            }, function (err) {
                _this.error = err;
            });
        });
    };
    MsalService = __decorate([
        core_1.Injectable()
    ], MsalService);
    return MsalService;
}());
exports.MsalService = MsalService;
